; d0=initial selection
; a0=menu
; Returns: d0=select (-1=esc pressed)
domenu:
        movem.l d1-d7/a0-a6,-(a7)

        move.l d0,d4
        move.l (a0),d0
        lsl.l #3,d0
        add.l #14,d0
        move.l d0,d5
        lsr.l #1,d0
        move.l d0,d1
        move.l #LCD_MID_Y,d0
        sub.l d1,d0
        mulu.w #30,d0
        add.l #LCD_MID_X_BYTES,d0
        move.l 4(a0),d1
        lsr.l #1,d1
        sub.l d1,d0
        move.l d0,d7
        move.l #30,d6
        sub.l 4(a0),d6

        move.l gplane1,a1
        move.l gplane0,a2
        add.l d7,a1
        add.l d7,a2
        move.l 4(a0),d0
        sub.l #1,d0
menuloop1:
        move.b #$ff,(a1)+
        move.b #$ff,(a2)+
        dbra d0,menuloop1

        add.l d6,a1
        add.l d6,a2

        move.l d5,d0
        sub.l #3,d0
menuloop2:
        move.b #$80,(a1)+
        move.b #$80,(a2)+
        move.l 4(a0),d1
        sub.l #3,d1
menuloop3:
        clr.b (a1)+
        clr.b (a2)+
        dbra d1,menuloop3
        move.b #1,(a1)+
        move.b #1,(a2)+
        add.l d6,a1
        add.l d6,a2
        dbra d0,menuloop2

        move.l 4(a0),d0
        sub.l #1,d0
menuloop4:
        move.b #$ff,(a1)+
        move.b #$ff,(a2)+
        dbra d0,menuloop4

        move.l gplane0,a2
        add.l d7,a2
        move.l #7,d0
menuloop5:
        move.l 4(a0),d1
        sub.l #1,d1
menuloop6:
        move.b #$ff,(a2)+
        dbra d1,menuloop6
        add.l d6,a2
        dbra d0,menuloop5

        move.l gplane1,a1
        add.l d7,a1
        add.l #240,a1
        move.l 4(a0),d0
        sub.l #1,d0
menuloop7:
        move.b #$ff,(a1)+
        move.b #$ff,(a2)+
        dbra d0,menuloop7

        move.l a0,a6
        move.l (a0),d0
        lsl.l #3,d0
        add.l #14,d0
        lsr.l #1,d0
        move.l d0,d1
        move.l #LCD_MID_Y,d0
        sub.l d1,d0
        move.l d0,d2
        move.l #LCD_MID_X,d0
        move.l 4(a0),d1
        lsr.l #1,d1
        lsl.l #3,d1
        sub.l d1,d0       
        move.l d0,d3

        movem.l d0-d7/a6,-(a7)
        move.w #0,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        movem.l (a7)+,d0-d7/a6

        movem.l d0-d7/a6,-(a7)
        move.w #4,-(a7)
        move.l 8(a6),-(a7)
        move.w d2,-(a7)
        add.w #2,(a7)
        move.w d3,-(a7)
        add.w #2,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        movem.l (a7)+,d0-d7/a6

        movem.l d0-d7/a6,-(a7)
        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        movem.l (a7)+,d0-d7/a6

        move.l d4,-(a7)
        move.l a6,a1
        add.l #12,a1
        move.l (a6),d1
        sub.l #1,d1
        move.l #11,d4
menuitemloop:
        movem.l d0-d7/a1-a6,-(a7)
        move.w #4,-(a7)
        move.l (a1),-(a7)
        move.w d2,-(a7)
        add.w d4,(a7)
        move.w d3,-(a7)
        add.w #8,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        movem.l (a7)+,d0-d7/a1-a6

        add.l #4,a1
        add.l #8,d4

        dbra d1,menuitemloop

        move.l (a7)+,d4

        move.l d4,d0
menuselloop:
        bsr hilitemenuitem
        move.l d0,d4
        movem.l d1-d7/a6,-(a7)
        bsr idle_loop
        and.l #$ffff,d0
        movem.l (a7)+,d1-d7/a6
        exg d0,d4
        bsr hilitemenuitem

        cmp.l #KEY_DOWN,d4
        beq menu_down
        cmp.l #264,d4
        beq menu_esc
        cmp.l #13,d4
        beq menu_enter
        cmp.l #KEY_UP,d4
        bne menuselloop

        sub.l #1,d0
        cmp.l #-1,d0
        bne menuselloop
        move.l (a6),d0
        sub.l #1,d0
        bra menuselloop

menu_down:
        add.l #1,d0
        cmp.l (a6),d0
        bne menuselloop
        move.l #0,d0
        bra menuselloop

menu_esc:
        move.l #-1,d0

menu_enter:
        movem.l (a7)+,d1-d7/a0-a6
        rts

hilitemenuitem:
        movem.l d0-d1/a1-a2,-(a7)

        move.l gplane1,a1
        move.l gplane0,a2
        add.l d7,a1
        add.l d7,a2
        add.l #330,a1
        add.l #330,a2
        lsl.l #3,d0
        mulu.w #30,d0
        add.l d0,a1
        add.l d0,a2
        move.l #7,d0
hiliteloop1:
        eor.b #$f,(a1)+
        eor.b #$f,(a2)+
        move.l 4(a6),d1
        sub.l #3,d1
hiliteloop2:
        eor.b #$ff,(a1)+
        eor.b #$ff,(a2)+
        dbra d1,hiliteloop2
        eor.b #$f0,(a1)+
        eor.b #$f0,(a2)+
        add.l d6,a1
        add.l d6,a2
        dbra d0,hiliteloop1

        movem.l (a7)+,d0-d1/a1-a2
        rts

